{% load staticfiles %}
<link rel="stylesheet" href="{% static 'game/block-alert/block-alert.css' %}">

<div class="container container-table">
    <div id="myfilter" style="position:absolute;background-color:#000000;opacity:0.3;display:none">
    </div>
    <div id="myrestartbutton" style="position:fixed;padding-top:5%;padding-left:1%;display:none;"><button
            onclick="restartGame()">Restart</button></div>
    <div id="mystartbutton" style="position:fixed;padding-top:1%;padding-left:1%;"><button
            onclick="startGame()">Start</button></div>
    <div id="canvascontainer"></div>
    <br>
    <div class="divActionBtns">
        <button ontouchstart="moveup()" onmousedown="moveup()" alt="UP" onmouseup="clearmove()">&uarr;</button><br><br>
        <button ontouchstart="moveleft()" onmousedown="moveleft()" alt="LEFT" onmouseup="clearmove()">&larr;</button>
        <button ontouchstart="moveright()" onmousedown="moveright()" alt="RIGHT" onmouseup="clearmove()">&rarr;</button><br><br>
        <button ontouchstart="movedown()" onmousedown="movedown()" alt="DOWN" onmouseup="clearmove()">&darr;</button>
    </div>
    <input type="hidden" name="hidGameObj" id="hidGameObj" value="{{gameObj}}">
</div>

<script>
    var myGameArea;
    var myGamePiece;
    var myObstacles = [];
    var myscore;
    var gCanvas;

    function restartGame() {
        document.getElementById("myfilter").style.display = "none";
        document.getElementById("myrestartbutton").style.display = "none";
        myGameArea.stop();
        myGameArea.clear();
        myGameArea = {};
        myGamePiece = {};
        myObstacles = [];
        myscore = {};
        document.getElementById("canvascontainer").innerHTML = "";
        startGame()
    }

    function startGame() {
        myGameArea = new gamearea();
        myGamePiece = new component(30, 30, "red", 10, 75);
        myscore = new component("15px", "Consolas", "black", 220, 25, "text");
        myGameArea.start();
        $("#mystartbutton").remove()
    }

    function gamearea() {
        this.canvas = document.createElement("canvas");
        gCanvas = this.canvas;
        // this.canvas.width = 320;
        // this.canvas.height = 180;
        document.getElementById("canvascontainer").appendChild(this.canvas);
        this.context = this.canvas.getContext("2d");
        this.pause = false;
        this.frameNo = 0;
        this.start = function () {
            this.interval = setInterval(updateGameArea, 20);
        }
        this.canvas.setAttribute('tabindex', '0');
        this.canvas.focus();

        this.canvas.onkeydown = function (evt) {
            evt = evt || window.event;
            if (evt.key == "ArrowDown") {
                movedown(window.event);
            }

            if (evt.key == "ArrowUp") {
                moveup(window.event);
            }
        };

        this.stop = function () {
            clearInterval(this.interval);
            this.pause = true;
        }
        this.clear = function () {
            this.context.clearRect(0, 0, this.canvas.width, this.canvas.height);
        }
    }

    function component(width, height, color, x, y, type) {

        this.type = type;
        if (type == "text") {
            this.text = color;
        }
        this.score = 0; this.width = width;
        this.height = height;
        this.speedX = 0;
        this.speedY = 0;
        this.x = x;
        this.y = y;
        this.update = function () {
            ctx = myGameArea.context;
            if (this.type == "text") {
                ctx.font = this.width + " " + this.height;
                ctx.fillStyle = color;
                ctx.fillText(this.text, this.x, this.y);
            } else {
                ctx.fillStyle = color;
                ctx.fillRect(this.x, this.y, this.width, this.height);
            }
        }
        this.crashWith = function (otherobj) {
            var myleft = this.x;
            var myright = this.x + (this.width);
            var mytop = this.y;
            var mybottom = this.y + (this.height);
            var otherleft = otherobj.x;
            var otherright = otherobj.x + (otherobj.width);
            var othertop = otherobj.y;
            var otherbottom = otherobj.y + (otherobj.height);
            var crash = true;
            if ((mybottom < othertop) || (mytop > otherbottom) || (myright < otherleft) || (myleft > otherright)) {
                crash = false;
            }
            return crash;
        }
    }

    function updateGameArea() {
        var x, y, min, max, height, gap;
        for (i = 0; i < myObstacles.length; i += 1) {
            if (myGamePiece.crashWith(myObstacles[i])) {
                myGameArea.stop();
                document.getElementById("myfilter").style.display = "block";
                document.getElementById("myrestartbutton").style.display = "block";
                //make ajax call to update score in model
                updateUserAppScore(myscore.score)
                return;
            }
        }
        if (myGameArea.pause == false) {
            myGameArea.clear();
            myGameArea.frameNo += 1;
            myscore.score += 0.1;
            myscore.score = Math.ceil(myscore.score)
            if (myGameArea.frameNo == 1 || everyinterval(150)) {
                x = myGameArea.canvas.width;
                y = myGameArea.canvas.height - 100;
                min = 20;
                max = 100;
                height = Math.floor(Math.random() * (max - min + 1) + min);
                min = 50;
                max = 100;
                gap = Math.floor(Math.random() * (max - min + 1) + min);
                myObstacles.push(new component(10, height, "green", x, 0));
                myObstacles.push(new component(10, x - height - gap, "green", x, height + gap));
            }
            for (i = 0; i < myObstacles.length; i += 1) {
                myObstacles[i].x += -1;
                myObstacles[i].update();
            }
            myscore.text = "SCORE: " + myscore.score;
            myscore.update();
            myGamePiece.x += myGamePiece.speedX;
            myGamePiece.y += myGamePiece.speedY;


            if (parseInt(myGamePiece.y) <= 0) {
                myGamePiece.y = (parseInt(myGameArea.canvas.height) / 2);
                // myGamePiece.update();
            } else if (parseInt(myGamePiece.y) >= (parseInt(myGameArea.canvas.height) - 1)) {
                // myGamePiece.speedY = parseInt(myGameArea.canvas.height);
                myGamePiece.y = (parseInt(myGameArea.canvas.height) / 2);
                // myGamePiece.update();
            } else {
                myGamePiece.update();
            }
        }
    }

    function everyinterval(n) {
        if ((myGameArea.frameNo / n) % 1 == 0) { return true; }
        return false;
    }

    function moveup(e) {
        myGamePiece.speedY = -1;
    }

    function movedown() {
        myGamePiece.speedY = 1;
    }

    function moveleft() {
        myGamePiece.speedX = -1;
    }

    function moveright() {
        myGamePiece.speedX = 1;
    }

    function clearmove(e) {
        myGamePiece.speedX = 0;
        myGamePiece.speedY = 0;
    }
    // startGame();

    $(document).ready(function () {
        $(document).find("canvas").attr('tabindex', '0');
        $(document).find("canvas").focus();
    });

    $(document).bind("keydown", function (evt) {
        $(document).find("canvas").attr('tabindex', '0');
        $(document).find("canvas").focus();
    });

    function updateUserAppScore(score) {

        $.ajax({
            url: '/games/updateScore/',
            dataType: 'text',
            type: 'post',
            headers: { "X-CSRFToken": getCookie("csrftoken") },
            // contentType: 'application/x-www-form-urlencoded',
            data: { "last_score": score, "gameObj": $("#hidGameObj").val() },
            success: function (data, textStatus, jQxhr) {
                // $('#response pre').html(data);
                console.log("AJAX Success");
                $("#spn_best_score").html(JSON.parse(data)["best_score"])
                $("#spn_highest_score").html(JSON.parse(data)["highest_score"])
                $("#spn_highest_scorer").html("("+JSON.parse(data)["highest_scorer"]+")")
                console.log(textStatus);
                console.log(jQxhr);
            },
            error: function (jqXhr, textStatus, errorThrown) {
                console.log("AJAX Error");
                console.log(jqXhr);
                console.log(errorThrown);
                console.log(textStatus);
            }
        });
    }

    function getCookie(c_name) {
        if (document.cookie.length > 0) {
            c_start = document.cookie.indexOf(c_name + "=");
            if (c_start != -1) {
                c_start = c_start + c_name.length + 1;
                c_end = document.cookie.indexOf(";", c_start);
                if (c_end == -1) c_end = document.cookie.length;
                return unescape(document.cookie.substring(c_start, c_end));
            }
        }
        return "";
    }

</script>